# ***** BEGIN GPL LICENSE BLOCK *****
#
# Script copyright (C) Gordon Allott 2008
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software Foundation,
# Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
#
# ***** END GPL LICENCE BLOCK *****
# --------------------------------------------------------------------------


import Blender
from Blender import Text3d, Window, Object
import bpy
import os
import math

from Blender import *

lineWidth = 20 #we can only fit 18 letters per line

try:
    author = os.getenv('upeople_author')
except:
    author = "foobar"

try:
    title = os.getenv('upeople_title').replace("\\n", "\n")
except:
    title = "foobar"

try:
    size = (int(os.getenv('upeople_width')), int(os.getenv('upeople_height')))
except:
    size = (640, 480)

def getspace(data):
    savedindex = 0
    for index in range(len(data)):
        item = data[index]
        if item == " ":
            savedindex = index
    return savedindex

def formatText2(data, width):
    """ formats data nicer, doesn't split words """
    if len(data) <= width:
        return data
    retstr = ""
    index = 0
    while True:
        # find the last space in our string
        tmpstring = data[index:][:width]
        if not tmpstring.rstrip().lstrip():
            break
        spaceindex = getspace(tmpstring)
        if spaceindex == 0:
            spaceindex = width

        retstr += tmpstring[:spaceindex].lstrip().rstrip() + "\n"
        index += spaceindex + 1
    return retstr.lstrip().rstrip()


def formatText(data, width):
    """ formats data to width line width"""
    newdata = []
    numlines = int(math.ceil(len(data) / float(width)))

    for i in range(numlines):
        index = i * width
        line = data[index:][:width]
        newdata.append(line)


    retstr = ""
    for line in newdata:
        retstr += line + "\n"




    return retstr

title = formatText2(title, lineWidth)
#author = formatText(author, lineWidth)

title = title.rstrip().lstrip()
author = author.rstrip().lstrip()
    #text object we need
txtobj = Text3d.Get("edittext_title")
txtobj.setText(title)

txtobj = Text3d.Get("edittext_author")
txtobj.setText(author)


scn = Scene.GetCurrent()
context = scn.getRenderingContext()
context.sizeX = size[0]
context.sizeY = size[1]

    #set the mem sequencer to be higher than the default, speeds up rendering hugely
bpy.config.sequenceMemCacheLimit = 512

