#!/usr/bin/env python
# -*- coding: utf-8 -*-
#       guiUploader.py
#
#       Copyright 2008 Gordon Allott <gordallott@gmail.com>
#
#       This program is free software; you can redistribute it and/or modify
#       it under the terms of the GNU General Public License as published by
#       the Free Software Foundation; either version 3 of the License, or
#       (at your option) any later version.
#
#       This program is distributed in the hope that it will be useful,
#       but WITHOUT ANY WARRANTY; without even the implied warranty of
#       MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#       GNU General Public License for more details.
#
#       You should have received a copy of the GNU General Public License
#       along with this program; if not, write to the Free Software
#       Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
#       MA 02110-1301, USA.
#
#
import sys, os
import pygtk
pygtk.require('2.0')
import gtk, gtk.glade, gobject
import resource


class view(object):
    """ gtk/glade object to provide the view """
    config = {
    }

    windowName = ''
    connectSignals = {}

    timers = {}

    returnData = None

    def __init__(self, config={}, wTree=None, callback=None):
        """
        inits the view, if you pass it a wTree it will use that instead of
        creating a new wTree instance
        callback is the function that should be run once we are done with this
        module of code
        """

        self.config = config
        self.callback = callback

        #replace this with nicer lookups
        self.gladefile = resource.get_resource("glade/app.glade")

        #self.wTree = wTree if wTree else gtk.glade.XML(self.gladefile)
        self.wTree = gtk.glade.XML(self.gladefile)

        if self.windowName:
            self.window = self.wTree.get_widget(self.windowName)
            #connect up a few signals

            if self.window:
                self.window.connect('destroy', self.destroy)

            if self.connectSignals:
                self.wTree.signal_autoconnect(self.connectSignals)

            self.window.show()

    def doCallback(self, senddata=False):
        """ sends the config back to whatever is the specified callback
        if senddata is false then None is sent back
        """
        if self.callback:
            if senddata:
                self.callback(data=self.returnData)
            else:
                self.callback(data=None)

        self.callback = None

    def getConfig(self):
        """ gets our current stuff and should store it in self.config
        this should be overridden
        """
        pass


    # -------- Signals go here --------


    def destroy(self, widget):
        if self.window:
            self.window.destroy()

        #tries to remove timer objects

        for attr in dir(self):
            if attr[:5] == "timer":
                if type(self.__getattribute__(attr)) == type(1):
                    gobject.source_remove(self.__getattribute__(attr))

        self.doCallback(senddata=True)


    def cancelButton(self, widget):
        self.returnData = None
        self.window.destroy()

    def okayButton(self, widget):

        self.getConfig()
        self.returnData = self.config
        self.window.destroy()
