#!/usr/bin/env python
# -*- coding: utf-8 -*-
#       guiUploadConfig.py
#
#       Copyright 2008 Gordon Allott <gordallott@gmail.com>
#
#       This program is free software; you can redistribute it and/or modify
#       it under the terms of the GNU General Public License as published by
#       the Free Software Foundation; either version 3 of the License, or
#       (at your option) any later version.
#
#       This program is distributed in the hope that it will be useful,
#       but WITHOUT ANY WARRANTY; without even the implied warranty of
#       MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#       GNU General Public License for more details.
#
#       You should have received a copy of the GNU General Public License
#       along with this program; if not, write to the Free Software
#       Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
#       MA 02110-1301, USA.
#
#
import sys, os
import pygtk
pygtk.require('2.0')
import gtk, gtk.glade, gobject
import resource, iconHandler
from resource import extVideo, extAudio, mb_it
import datetime
from math import *
import pygst
pygst.require("0.10")
import gst

from os import path as ospath
from resource import slugify

import gui


class view(gui.view):
    """ gtk/glade object to provide the view """

    windowName = 'uconfig'

    def __init__(self, config={}, wTree=None, callback=None):

        self.connectSignals = {
            'on_uconfig_TitleEntry_changed': self.textChanged,
            'on_uconfig_PasswordEntry_changed':  self.textChanged,
            'on_uconfig_UsernameEntry_changed': self.textChanged,

            "on_uconfig_OkayButton_clicked" : self.okayButton,
            "on_uconfig_CancelButton_clicked" : self.cancelButton,
        }

        gui.view.__init__(self, config=config, wTree=wTree, callback=callback)

        self.wTree.get_widget('uconfig_textviewDescription').get_buffer().connect('changed', self.textChanged)

        ## set our defaults

        self.wTree.get_widget('uconfig_TitleEntry').set_text(self.config['title'])

        tbuf = self.wTree.get_widget('uconfig_textviewDescription').get_buffer()
        tbuf.set_text(self.config['description'])


    def getConfig(self):
        """ gets our current stuff """
        self.config['title'] = self.wTree.get_widget('uconfig_TitleEntry').get_text()
        tbuf = self.wTree.get_widget('uconfig_textviewDescription').get_buffer()
        self.config['description'] = tbuf.get_text(tbuf.get_start_iter(), tbuf.get_end_iter())

        self.config['username'] = self.wTree.get_widget('uconfig_UsernameEntry').get_text()
        self.config['password'] = self.wTree.get_widget('uconfig_PasswordEntry').get_text()


#   ---------- callbacks ----------

    def textChanged(self, widget):
        done = True

        if not self.wTree.get_widget('uconfig_TitleEntry').get_text():
            done = False

        if not self.wTree.get_widget('uconfig_UsernameEntry').get_text():
            done = False

        if not self.wTree.get_widget('uconfig_PasswordEntry').get_text():
            done = False

        texbuf = self.wTree.get_widget('uconfig_textviewDescription').get_buffer()
        if not texbuf.get_text(texbuf.get_start_iter(), texbuf.get_end_iter()):
            done = False

        if done:
            self.wTree.get_widget('uconfig_OkayButton').set_sensitive(True)
        else:
            self.wTree.get_widget('uconfig_OkayButton').set_sensitive(False)
