#!/usr/bin/env python
# -*- coding: utf-8 -*-
#       httplibnb.py
#
#       Copyright 2008 Gord Allott <gordallott@gmail.com>
#
#       This program is free software; you can redistribute it and/or modify
#       it under the terms of the GNU General Public License as published by
#       the Free Software Foundation; either version 3 of the License, or
#       (at your option) any later version.
#
#       This program is distributed in the hope that it will be useful,
#       but WITHOUT ANY WARRANTY; without even the implied warranty of
#       MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#       GNU General Public License for more details.
#
#       You should have received a copy of the GNU General Public License
#       along with this program; if not, write to the Free Software
#       Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
#       MA 02110-1301, USA.
#
import gsocket
from urllib import urlencode
import os, sys
import httplib, socket
import gobject
import re
from re import IGNORECASE, DOTALL
from string import Template
import string
import random


cregex_extractForm = re.compile(r'<form.*?>(?P<formhtml>.*?)</form>', IGNORECASE)
#cregex_getInputs = re.compile(r'(?:\<input(?P<content>.*?)>)', IGNORECASE|MULTILINE)
cregex_getInputs = re.compile(r'(?:\<(?P<content>(input|textarea|button).*?)>)', IGNORECASE)


#ALL THIS DOES NOT WORK, I AM GIVING UP ON IT.
# HOWEVER!! if someone else wants to get it working nicely that would be fantastic
#class FormExtract(object):
    #""" a class designed to extract form objects from html files """

    #def __init__(self):
        #self.re_extractForm = re.compile(r'<form.*?>(?P<formhtml>.*?)</form>', IGNORECASE|DOTALL)

        #self.re_getInputs = re.compile(r'(?:\<(?P<content>(input|button).*?)/?>)', IGNORECASE|DOTALL)
        #self.re_getTextAreas = re.compile(r'<textarea.*?name="(?P<name>.*?)".*?>(?P<value>.*?)</textarea>', IGNORECASE|DOTALL)

        #self.re_getSelects = re.compile(r'<select.*?name="(?P<name>.*?)".*?>(?P<options>.*?)</select>', IGNORECASE|DOTALL)
        #self.re_matchOption = re.compile(r'<option.*?value="(?P<value>.*?)".*?>', IGNORECASE|DOTALL)
        #self.re_matchSelected = re.compile(r'<option value="(?P<value>(?:\w|\d)*)"(?:(\w|\s)*="(\w|\s)*")* selected="selected".*?>', IGNORECASE)


        #self.re_inputHidden = re.compile(r'<input.*?type="hidden".*?name="(?P<name>(?:\w|\d)*?)".*?value="(?P<value>(?:\w|\d)*?).*?/?>', IGNORECASE)
        #self.re_inputText = re.compile(r'<input.*?type="(text|password)".*?name="(?P<name>(?:\w|\d)*?)".*?value="(?P<value>(?:\w|\d)*?).*?/?>', IGNORECASE)

    #def getSelects(self, html):
        #""" takes the given html and returns a list of (name, value) for the
        #select tags it finds. will try and follow selected options but if one
        #is not found the first option is used
        #"""

        #selectTags = self.re_getSelects.finditer(html)
        #if not selectTags:
            #return []

        #retlist = []
        #for sTag in selectTags:
            #content = sTag.groupdict()
            #if not content:
                #continue
            #name = content['name']
            #options = content['options']

            ##try and get a selected tag first
            #print options
            #selected = self.re_matchSelected.search(options)
            #if selected:
               #value = selected.groupdict()['value']
            #else:
                ##no selected tag so lets just get the first option we find
                #option = self.re_matchOption.search(options)

                #if option:
                    #value = option.groupdict()['value']
                #else:
                    #value = ''

            #retlist.append((name, value))

        #return retlist

    #def getTextAreas(self, html):
        #""" takes the given html, returns a list of (name, value) for the
        #text areas it finds
        #"""
        #matches = self.re_getTextAreas.finditer(html)
        #if not matches:
            #return []

        #retlist = []
        #for match in matches:
            #content = match.groupdict()
            #if not content:
                #continue

            #retlist.append((content['name'], content['value']))

        #return retlist


    #def extract(self, html):
        #""" extracts form info from raw html """
        #match = self.re_extractForm.search(html)
        #if not match:
            #raise Exception, 'no form in html'

        #html = match.groupdict()['formhtml']
        ##we now have all the html between our <form></form> tags

        #print self.getSelects(html)


        ##matches = self.re_getInputs.finditer(html)
        ### matches now contains all our <input/textarea/button> tags

        ##for match in matches:
            ##try:
                ##tag = match.groupdict()['content']
            ##except:
                ##pass

            ###lets see where we are shall we...
            ##print "-----"
            ##print tag




class Http(object):
    """ Http object handles the stuff with the junk """

    recv_buf = ""
    regexURL = None
    lock = False
    socket = None

    header = ""
    body = ""

    callback = None

    doneHeader = False
    bodyLen = 0

    mimeheader = '---------------------------1237686171021883274437877188'

    def reset(self):
        """ resets all data """
        self.recv_buf = ""
        self.header = ""
        self.body = ""

        self.callback = None
        self.doneHeader = False
        self.bodyLen = 0

    def genmime(self, mimelen=55):
        """ generates a mime header of given length """

        retstr = ''
        for i in range(mimelen):
            retstr += string.ascii_letters[random.randrange(len(string.ascii_letters))]
        return retstr

    def __init__(self):
        self.regexURL = re.compile(r'(?:http://)?(?P<host>(?:\w+\.)*\w+(?:\.\w+)?)(?P<path>/.*)?')
        self.mimheader = self.genmime()

    def makeheaders(self, headers):
        """ returns a string for HTTP from a dict of headers """
        if not headers:
            return ""

        retstr = ""

        tmpheaders = {}
        for key, value in headers.iteritems():
            tmpheaders[key] = value


        for label in ['host', 'Host', 'HOST']:
            if tmpheaders.has_key(label):
                key, value = ('Host', tmpheaders[label])
                retstr  += key.rstrip().lstrip() + ": "\
                        +  value.replace("\r\n", "").replace("\n", "")\
                        + "\r\n"
                tmpheaders.pop(label)


        #next we want anything but Content-Length or Content-Type

        for key, value in tmpheaders.iteritems():
            if not (key.lower() in ['content-length', 'content-type']):
                retstr  += key.rstrip().lstrip() + ": "\
                        +  value.rstrip().lstrip().replace("\r\n", "").replace("\n", "")\
                        + "\r\n"


        for label in ['content-type', 'Content-Type', 'CONTENT-TYPE']:
            if tmpheaders.has_key(label):
                key, value = ('Content-Type', tmpheaders[label])
                retstr  += key.rstrip().lstrip() + ": "\
                        +  value.replace("\r\n", "").replace("\n", "")\
                        + "\r\n"
                tmpheaders.pop(label)

        for label in ['content-length', 'Content-Length', 'CONTENT-LENGTH']:
            if tmpheaders.has_key(label):
                key, value = ('Content-Length', tmpheaders[label])
                retstr  += key.rstrip().lstrip() + ": "\
                        +  value.replace("\r\n", "").replace("\n", "")\
                        + "\r\n"
                tmpheaders.pop(label)

        return retstr

    def spliturl(self, url):
        """ splits a url in the form http://foo.bar.moo/page/hello?q=foo&bar
        into two parts, the host 'foo.bar.moo' and the request
        '/page/hello?q=foo&bar'
        """
        url = url.replace("\n","").replace("\r", "").rstrip().lstrip()
        matches = self.regexURL.match(url)

        if matches.groupdict().has_key('host'):
            host = matches.groupdict()['host']
        else:
            host = ''

        if matches.groupdict().has_key('path'):
            path = matches.groupdict()['path']
        else:
            path = '/'

        return (host, path)

    def normalizeHeaders(self, headers):
        """ simply makes sure all the keys are lower case """
        ret = {}
        for key, value in headers.iteritems():
            ret[key.lower()] = value.rstrip().lstrip().replace("\r", "").replace("\n", "")

        return ret

    def urlencode(self, query):
        """ runs urlencode on our custom data mapping """
        nicetype = {}
        for key, value in query.iteritems():
            data, type = value

            nicetype[key] = value[0]


        return urlencode(nicetype)


    def multipart(self, form):
        """
        takes a dictionary describing a form and converts it into a list of
        strings and file objects that reflect http multipart/form-data
        data
        """
        # expects data in the form of (data, type)
        # if data is a file then it should be the file path to said file (or
        #   empty if you don't want to actually upload said file)

        retlist = []
        field   = Template('--$mime\nContent-Disposition: form-data; name="$name"\n\n$content\n')
        binary  = Template('--$mime\nContent-Disposition: form-data; name="$name"; filename="$filename"\nContent-Type: $mimetype\n\n')#
        final   = Template('--$mime--\n')

        bytes = 0

        mimetypes = {
            'ogg': 'application/ogg',
            'avi': 'video/avi',
            'mpeg': 'video/quicktime',
            'mpg': 'video/quicktime',
            'mov': 'video/quicktime',
            'rm': 'application/vnd',
            'flv': 'flv-application/octet-stream',
            'wmv': 'video/x-ms-wmv',
            '3gp': 'video/3gpp',
            'mp4': 'video/mp4',
            'dir': 'application/x-director',
            'dcr': 'application/x-director'
        }


        mimetypedefault = 'application/octet-stream'


        for key, value in form.iteritems():
            data, type = value
            item = ""

            if type == "string":
                item = field.substitute(mime = self.mimeheader,
                                        name = key,
                                        content = data
                                        )
                retlist.append(item.replace("\n", "\r\n"))
                bytes += len(retlist[-1])

            if type == "file":
                ext = os.path.splitext(data)[1].replace(".", "").lstrip().rstrip()
                filemime = mimetypedefault
                if mimetypes.has_key(ext):
                    filemime = mimetypes[ext]


                item = binary.substitute(mime = self.mimeheader,
                                        name = key,
                                        filename = os.path.split(data)[1],
                                        mimetype = filemime
                                        )

                if data == "" or not os.path.exists(data):
                    # no filename was given or the file doesn't exist so we
                    # will just blank the data
                    item += "\n"

                retlist.append(item.replace("\n", "\r\n"))
                bytes += len(retlist[-1])

                if data and os.path.exists(data):
                    filesize = os.path.getsize(data)
                    bin = open(data, "rb")
                    retlist.append((bin, filesize))
                    bytes += filesize

                    #we have to add a \r\n again :)
                    retlist.append('\n'.replace("\n", "\r\n"))
                    bytes += len(retlist[-1])


        retlist.append(final.substitute(mime = self.mimeheader).replace("\n", "\r\n"))
        bytes += len(retlist[-1])

        return (retlist, bytes)


    def request(self, url, callback,
                method='GET', headers={}, form={}, multipart=False):
        """ form should be in the form of a mapping of tuples """

        if self.lock:
            raise Exception, 'function is locked'

        self.reset()

        if callback:
            self.callback = callback

        host, path = self.spliturl(url)
        headers = self.normalizeHeaders(headers)

        headers['host'] = host
        if not headers.has_key('user-agent'):
            headers['User-Agent'] = "Python/httplibnb"

        headers['Connection'] = 'close'

        if method.lower() == 'post':
            #set our content type accordingly
            if not multipart:
                headers['content-type'] = 'application/x-www-form-urlencoded'
            else:
                headers['content-type'] = 'multipart/form-data; boundary=%s' % (self.mimeheader)

        # we store our content as a list of strings and files that we then
        # push to the socket object
        content = []
        length = 0
        if method.lower() == 'post':
            #we are putting data so we need to handle our content

            if not multipart:
                #not multipart data so we can just urlencode our form
                content = [self.urlencode(form)]
                length = len(content[0])
            else:
                content, length = self.multipart(form)

            headers['content-length'] = str(length)


        #add some rather useful headers ;)
        headers['host'] = host

        # build our header string
        outheader = Template("$method $path HTTP/1.1\n$headers\n".replace("\n", "\r\n"))
        outheader = outheader.substitute(   method = method.upper(),
                                            path = path,
                                            headers = self.makeheaders(headers)
                                        )

        #THIS IS ALL DEBUG STUFF
        if False:
            tmpout = ""
            tmpout += outheader

            for data in content:
                if type(data) == type(""):
                    tmpout += data

                if type(data) == type(()):
                    tmpout += "- FILE - (size = " + str(data[1]) + ")"


            print tmpout

        #figure out the total message size
        outbytes = len(outheader)


        # make our socket
        self.socket = gsocket.gSocket()
        self.socket.connect((host, 80))

        self.socket.writestr(outheader)

        if content:
            for data in content:
                if type(data) == type(""):
                    self.socket.writestr(data)
                    outbytes += len(data)

                if type(data) == type(()):
                    self.socket.writefile(data)
                    outbytes += data[1]

            self.socket.writestr("\r\n")

        self.socket.setReadCallback(self.callbackRead)
        self.lock = True

        return outbytes


    def processHeader(self, data):
        """ processes a string (a header string) into a nice dictionary of
        header values
        """
        regex_status = r'HTTP/(?P<version>\d(?:\.\d+)?) (?P<status>\d+) .*'
        regex_keyvalue = r'(?P<key>.*): (?P<value>.*)'
        re_cookie = re.compile(r'(?P<session>\w+)=(?P<cookie>\w*);? ?')

        retmapping = {}

        matches = re.finditer(regex_keyvalue, data)
        for match in matches:
            key = match.groupdict()['key']
            value = match.groupdict()['value']

            if key.lower() == 'set-cookie':
                #we handle cookies specialy to catch 'deleted'

                cmatch = re_cookie.search(value)
                if not cmatch:
                    pass

                if cmatch.groupdict()['cookie'] == 'deleted':
                    pass

                retmapping[key] = cmatch.groupdict()['session'] + "=" + cmatch.groupdict()['cookie']

            else:
                retmapping[key] = value


        return self.normalizeHeaders(retmapping)




    def readHeader(self, data):
        """ reads a header from given data, returns False unless the header
        has finished, in that case it returns the non header data
        """
        newbuf = self.recv_buf + data

        #try and find \r\n\r\n or \n\n in our recv_buf, lowest one counts
        lf = newbuf.find("\n\n")
        cr = newbuf.find("\r\n\r\n")

        if lf == -1 and cr == -1:
            self.recv_buf = newbuf
            return False

        pos = 0
        pad = 0
        if lf != cr:
            #one is larger than the other
            if lf < cr and lf != -1:
                pos = lf
                pad = 2
            else:
                pos = cr
                pad = 4
            #we now have our position in the string where the headers end

        #create the header item, return the data left over (minus our newlines)
        self.header = newbuf[:pos]

        self.recv_buf = ""

        retdata = ""
        try:
            retdata = newbuf[pos+pad:]

        except:
            return True

        return retdata

    def readBody(self, data, length):
        """ reads from data returning True until the stored buffer is as large
        as length, at that point returns False
        """

        # first of all, if length is -1 then we need to go into chunked mode
        # chunked mode essentially has a hexidecimal encoded figure at the top
        # of the body data, this figure is representative of how large the body
        # data is

        if length == -1:
            if data.find("\n") > 0:
                topline = data.splitlines()[0].rstrip().lstrip()
                self.bodyLen = int(str(topline), 16)
                length = self.bodyLen
                # trim off our chunk info
                data = data[data.find("\n") + 1:]
            else:
                # we havn't got our new line yet.. either unluckly or its broken
                # lets let the rest of the function grab the data and hope that
                # we get it next time...

                length = 1024*1024

        prelen = len(self.recv_buf)
        postlen = prelen + len(data)

        if postlen >= length:
            self.body = self.recv_buf + data[:length - prelen]
            return False

        self.recv_buf += data
        return True


    def callbackRead(self, data):

        if not data:
            self.doCallback()
            return False



        if not self.doneHeader:
            # post to read header
            data = self.readHeader(data)
            if data:
                self.doneHeader = True
                #read header to find out content length, store in self.bodyLen
                self.header = self.processHeader(self.header)

                if self.header.has_key('content-length'):
                    #print 'Content-length'
                    self.bodyLen = int(self.header['content-length'])


                elif self.header.has_key('transfer-encoding'):
                    #print 'transfer-encoding'
                    # we didn't get a content length... hopefully we got
                    # Transfer-Encoding: chunked else we are fecked
                    self.bodyLen = -1

                else:
                    raise Exception, 'no content-length or transfer-encoding'


        if self.doneHeader:
            #print "done header, using content length %i" % (self.bodyLen)
            #print "current size of body data is %i" % (len(self.recv_buf))
            if self.bodyLen != 0:
                # if data is litterally 'True' then we have no extra data to read
                if not data == True:
                    data = self.readBody(data, self.bodyLen)
                    if not data:
                        #done reading from body

                        self.doCallback()
                        return False
            else:
                self.doCallback()
                return False


        return True



    def doCallback(self):
        """ runs the callback back and closes our sockets and the like """
        #print "callback"
        #print self.callback
        if self.socket:
            self.socket.close()

        self.socket = None
        self.lock = False

        if len(self.body) < self.bodyLen:
            print "oops.. body is short by %i" % (self.bodyLen - len(self.body))

        if type(self.header) == type(""):
            self.header = self.processHeader(self.header)

        if self.callback:
            callback = self.callback
            self.callback = None
            callback(self.header, self.body)



    def close(self):
        self.doCallback()




class CookieJar(dict):
    """ a class that stores cookies, designed to be interfaced with httlibnb
    """

    def update(self, header):
        """ pass this our custom header mapping to store cookies """
        if header.has_key('set-cookie'):
            session, cookie = header['set-cookie'].split("=")
            self[session] = cookie

    def asString(self):
        """ outputs the current cookie jar as a string ready to be used in a
        cookie header
        """
        retstr = ""
        for key, value in self.iteritems():
            retstr = key + "=" + value
            retstr += ";"

        retstr = retstr.rstrip()[:-1]
        return retstr



cookies = CookieJar()
tmpobj = Http()


doLocal = False
loginUrl = ''
uploadUrl = ''
if doLocal:
    loginUrl = 'http://localhost/?q=user'
    uploadUrl = 'http://localhost/?q=node/add/page'

else:
    loginUrl = 'http://ubuntupeople.tv/user'
    uploadUrl = 'http://ubuntupeople.tv/node/add/page'

#filename = '/home/gord/Videos/testUpload.ogg'
filename = '/home/gord/ubuntu-uploader/test.txt'
#filename = '/home/gord/ubuntu-uploader/uploadfile.txt'

# All this stuff is for testing and not for use

def callback_postPost(header, body):
    #here we just post the data

    if header.has_key('location'):
        print "Success!!! we made a new page"
        print header['location']

    else:
        print 'bleh, didnt work :('
        print body, header
        sys.exit(0)

    sys.exit(0)

def callback_prePost(header, body):
    #here we collect our cookies and then try to submit a new post
    print "Attempting to post a new page"
    ##lets try and upload a new post now huh
    global cookies
    cookies.update(header)
    headers = {
        'Referer': uploadUrl,
        'Cookie': cookies.asString()
    }


    #we need to extract our form_token from the body
    try:
        match = re.search(r'<input.*?name="form_token".*?value="(?P<formtoken>\w+)".*?/>', body)
        formtoken = match.groupdict()['formtoken']
    except:
        print header
        formtoken = ""


    title = 'Foobar this is a test - %f' % (random.random())
    body = 'they call me mellow yello... quite nicely\n test test %f test test\n roar' % (random.random())


    form = {
        'title': (title, 'string'),
        'changed': ('', 'string'),
        'body': (body, 'string'),
        'form_token': (formtoken, 'string'),
        'form_id': ('page_node_form', 'string'),
        'log': ('', 'string'),
        'files[upload]': ('', 'file'),
        'attach-url': ('http://localhost/?q=upload/js', 'string'),
        'vid': ('', 'string'),
        'comment': ('0', 'string'),
        'menu[title]': ('', 'string'),
        'menu[description]': ('', 'string'),
        'menu[pid]': ('1', 'string'),
        'menu[path]': ('', 'string'),
        'menu[weight]': ('0', 'string'),
        'menu[mid]': ('0', 'string'),
        'menu[type]': ('86', 'string'),
        'name': ('gordallott', 'string'),
        'date': ('', 'string'),
        'status': ('1', 'string'),
        'op': ('Submit', 'string'),
    }

    tmpobj.request(uploadUrl, callback_postPost,
                    method='POST', headers=headers, multipart=True, form=form)


def callback_midUpload(header, body):
    print "actually posting our content now"

    global cookies
    cookies.update(header)
    headers = {
        'Referer': uploadUrl,
        'Cookie': cookies.asString()
    }

    #filename = '/home/gord/Videos/testUpload.ogg'


    #we need to extract our form_token from the body
    try:
        match = re.search(r'<input.*?name="form_token".*?value="(?P<formtoken>\w+)".*?/>', body)
        formtoken = match.groupdict()['formtoken']
    except:
        print header
        formtoken = ""


    form = {
        'title': ('TestUpload', 'string'),
        'changed': ('', 'string'),
        'body': ('[video]', 'string'),
        'form_token': (formtoken, 'string'),
        'form_id': ('page_node_form', 'string'),
        'log': ('', 'string'),
        'files[upload]': ('', 'file'),
        'attach-url': ('http://localhost/?q=upload/js', 'string'),
        'vid': ('', 'string'),
        'comment': ('0', 'string'),
        'menu[title]': ('', 'string'),
        'menu[description]': ('', 'string'),
        'menu[pid]': ('1', 'string'),
        'menu[path]': ('', 'string'),
        'menu[weight]': ('0', 'string'),
        'menu[mid]': ('0', 'string'),
        'menu[type]': ('86', 'string'),
        'name': ('gordallott', 'string'),
        'date': ('', 'string'),
        'status': ('1', 'string'),

        'files[upload_0][list]': ('1', 'string'),
        'files[upload_0][description]': (os.path.split(filename)[1], 'string'),

        'op': ('Submit', 'string'),

    }

    tmpobj.request(uploadUrl, callback_postPost,
                    method='POST', headers=headers, multipart=True, form=form)

#This is an upload test, well upload test file at any rate. lets just let it
#eat up a few megabytes first shall we.... ho hum...




def callback_preUpload(header, body):
    print "Attempting to upload a test file"
    ##lets try and upload a new post now huh
    global cookies
    cookies.update(header)
    headers = {
        'Referer': uploadUrl,
        'Cookie': cookies.asString()
    }

    #filename = '/home/gord/Videos/testUpload.ogg'


    #we need to extract our form_token from the body
    try:
        match = re.search(r'<input.*?name="form_token".*?value="(?P<formtoken>\w+)".*?/>', body)
        formtoken = match.groupdict()['formtoken']
    except:
        print header
        formtoken = ""


    form = {
        'title': ('TestUpload', 'string'),
        'changed': ('', 'string'),
        'body': ('[video]', 'string'),
        'form_token': (formtoken, 'string'),
        'form_id': ('page_node_form', 'string'),
        'log': ('', 'string'),
        'files[upload]': (filename, 'file'),
        'attach-url': ('http://localhost/?q=upload/js', 'string'),
        'vid': ('', 'string'),
        'comment': ('0', 'string'),
        'menu[title]': ('', 'string'),
        'menu[description]': ('', 'string'),
        'menu[pid]': ('1', 'string'),
        'menu[path]': ('', 'string'),
        'menu[weight]': ('0', 'string'),
        'menu[mid]': ('0', 'string'),
        'menu[type]': ('86', 'string'),
        'name': ('gordallott', 'string'),
        'date': ('', 'string'),
        'status': ('1', 'string'),
    }

    #we add 'attach' to the form as we are uploading
    form['attach'] = ('Attach', 'string')

    tmpobj.request(uploadUrl, callback_midUpload,
                    method='POST', headers=headers, multipart=True, form=form)


def callback2(header, body):
    # here we should get a new 'location' in the header

    if header.has_key('location'):
        print "Success!!! we logged in :)"

    else:
        print 'bleh, didnt work :('#
        print body, header
        sys.exit(0)



    ##lets try and upload a new post now huh
    global cookies
    cookies.update(header)
    headers = {
        'Referer': loginUrl,
        'Cookie': cookies.asString()
    }

    tmpobj.request(uploadUrl, callback_preUpload,
                    method='GET', headers=headers)


def callback1(header, body):
    #first we get a cookie
    print "Attempting to login"
    global cookies

    cookies.update(header)

    headers = {
        'Referer': loginUrl,
        'Cookie': cookies.asString()
    }
    #headers[ pushCookies(headers, cookies)
    myform = {
        'name': ('testuser', 'string'),
        'pass': ('testuser', 'string'),
        'form_id':('user_login', 'string'),
        'op':('Log in', 'string'),
    }

    tmpobj.request(loginUrl, callback2, headers=headers,
                    method='POST', form=myform)



def start():
    print "Start!"
    tmpobj.request(loginUrl, callback1)

if __name__ == "__main__":
    #just for testing


    start()


    gobject.MainLoop().run()













