#! /usr/bin/env python
# -*- coding: utf-8 -*-
#    This file is part of ubuntu-uploader.
#
#    ubuntu-uploader is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    ubuntu-uploader is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with ubuntu-uploader.  If not, see <http://www.gnu.org/licenses/>.
import os, sys

import pygtk
import gtk, gtk.glade
import resource

import guiLibrary
from library import mediaLibrary

if __name__ == "__main__":

    #first we figure out weather we have a per-user directory
    user_dir = os.path.expanduser('~/.ubuntu-uploader/')
    if not os.path.exists(user_dir):
        try:
            os.mkdir(user_dir)
        except:
            sys.exit(-1)
            print "Error: could not create user directory in " + user_dir +\
            "please check your permissions"

    # load our media library
    myLibrary = mediaLibrary(xmlfile=os.path.join(user_dir, "medialibrary.xml"))

    #find our glade file
    gladefile = resource.get_resource("glade/app.glade")

    wTree = gtk.glade.XML(gladefile)

    gui = guiLibrary.view(wTree=wTree)
    # make sure we pass our media library to our gtk view
    gui.attachLibrary(myLibrary)

    # start our main loop
    gtk.gdk.threads_init()
    gtk.main()

    #make sure to save the library on exit
    #myLibrary.saveXML()

